; OKDATA1 is a DSEG area for OPTIKS.
; OKDATA1 has utility data area which are generally common to many procs
;
dseg        SEGMENT PUBLIC 'DATA'
ASSUME      DS:dseg,ES:dseg
PUBLIC      breaker,buffer,comline,entry_mode
PUBLIC      maxlines,psp,ret_sp,sav_brk,start_stack
PUBLIC      err2,hash_segment,strg,handle
PUBLIC      gtable,attcopy,ttable,keyline
PUBLIC      mode,interlace,vbuffer,vid_wid,vid_len,color,palette
public      quitter,goback1,err1,helpno,last_si,last_seg
PUBLIC      curx,cury,last_fseg,last_fsi
public      comsi,str_len,siloc,curr_seg,p_seg
public      e_file,srow,scol,lrow,lcol
public      curr_dta,file_name,buffer_segment
public      pass,file_size,width_bytes,height_pix
public      crc_val,left_margin,save_font
public      fx,fy,clean,r_index,spoint,lpoint
public      width_pix,pel_size,work_seg,work2_seg
public      vint,vphase,helps,mouse_on
public      ems_name,ems_handle,ems_frame,ems_allocated,ems_free
public      fat_on,xor_raw
public      planes,iff_sw
public      color_map
public egavga
public cdir,cdisk,sdisk,sdir
public fsize,fdate,info_sw
;
;

            DB    'OPTIKS (r) Graphics Base',13,10
            DB    'Copyright 1992 by Keith P. Graham',26
attcopy     DB    'C)   OLIVETTI 1984' ;AT&T bios copyright
; 0 = black on white
; 1 = white on black
; 2 = or black on white to screen
; 3 = or white on black to screen
; 4 = and black on white to screen
; 5 = and white on black to screen
; 6 = xor black on white to screen
; 7 = xor white on black to screen
breaker     DW    0     ;sp register for return after break
brandfind   db    "BrAnD="
brand       dw    0
brandname   db    " Unregistered. Please call for BRAND ID."
brandcheck  dw    0
public brand,brandname,brandcheck
buffer_segment equ this word  ; alternate use
buffer      DW    0     ;address of i-o buffers
cdisk       db    0     ; current disk
cdir        db    64  dup(0)  ; current dir
clean       db    0     ; used to tell finger when pres clears screen
color       DB    0     ; color for cga modes
color_map   db    0     ; nice colors for use in 4 plane
            db    41,57,31,54,47,14h,14,28h,39h,2ah,3bh,2ch,2dh,1eh,3fh
;           db    41,21,31,54,47,14h,74,28h,39h,2ah,3bh,2ch,2dh,7eh,3fh
            db    0
comline     DB    132   DUP(0)      ; command line storage area
comsi       dw    0     ; offset into current macro line
crc_val     dw    0     ; crc used in pcr
curr_dta    equ this byte  ; dta area for directory listings
            db    21   dup(0) ; used by dos
fattrib     db    0     ; file attribute
public fattrib
ftime       dw    0     ; file time
fdate       dw    0     ; file date
fsize       dw    0,0   ; file size
file_name   db    13   dup(0) ; used in listfiles
            db    20   dup(0)  ; wasted
ems_allocated dw 0  ; amount actually allocated
ems_frame   dw    0     ; these are used by the ems routines
ems_free    dw    0     ; free memory left after allocation
ems_handle  dw    0
ems_name    db    'EMMXXXX0',0
curr_seg    dw    0     ; the current segment number
curx        DW    0     ; cursor x location
cury        DW    0     ; cursor y location
e_file      db    'File Name: ',0
;   201  200  205  188  186  187
entry_mode  DB    0     ; video mode at startup
egavga     db    0
file_size   dw    0,0   ; used by file procs
            dw    0
fat_on      db    0     ; tells when fat bits are on
fx          dw    0     ; current finger x in bits
fy          dw    0     ; finger y in lines
goback1     dw    0     ; way out of tree - up one level
gtable      DB    35h,2dh,2eh,07h ;hercules graphics mode table
            DB    5bh,02h,57h,57h
            DB    02h,03h,00h,00h
handle      DW    0     ; file handle for standard routines
hash_segment DW   0     ; address of data area used by LZ routines
height_pix   dw   0     ; height of a picture in file procs
helpno      dw    0     ; number of current help screen
helps       dw    0     ; source of current help request
iff_sw      db    0
info_sw     db    0     ; used to tell program to stop after header
interlace   DW    0     ; interlace lines
; keyline is the data for the scan codes, converts to various nums
keyline db  1,28,75,77,71,72,79,80,73,81,53,52,59,60,61,62,63  ;17
        db  64,65,66,67,68,77h,75h,73h,74h,84h,76h             ;28
        db  0,0,0,0,0
last_si     dw    0     ; si offset of last screen
last_seg    dw    0     ; segment number of last screen
last_fsi     dw    0     ; si offset of last screen (fat)
last_fseg    dw    0     ; segment number of last screen (fat)
lcol        dw    0     ; last column of a range (real)
left_margin dw    0     ; left margin used by print_string
lpoint      dw    0     ; point number of last column
lrow        dw    0     ; last row of a range (real)
maxlines    DW    0     ; count of lines in video buffers
mode        DB    0     ; current video mode
            db    0
mouse_on    db    0     ; mouse presense switch
            dw    0
p_seg       dw    24    dup(0)  ; current segments of action
palette     DB    0     ; color for cga modes
pass        dw    0     ; used by file procs to tell what pass
pel_size    dw    0     ; used in CUT and others
planes      dw    1     ; number of color planes
psp         DW    0     ; address of PSP of start up (DS register)
quitter     DW    0     ; quit address (sp reg)
r_index     dw    0     ; this is the index of the range function
ret_sp      DW    0     ; this is the sp reg at startup, used to exit
save_font   dw    0     ; selected font is saved here
sav_brk     DW    0,0         ; where break address is stored
scol        dw    0     ; starting column of a range
sdisk       db    0     ; starting disk
sdir        db    64  dup(0)  ; current dir
siloc       dw    0     ; the current si offset into picture of ulhc
spoint      dw    0     ; starting point
srow        dw    0     ; starting row of a range
start_stack DW    0     ; address of startup stack
;trg equ this byte
strg        DB    128   DUP(0)      ; input string area
str_len     dw    0     ; length of string requested
ttable  db      61h,50h,52h,0fh
        db      19h,06h,19h,19h
        db      02h,0dh,0bh,0ch
width_pix   dw    0     ; CUT and other files
width_bytes dw    0     ; width in bytes for picture file procs
work_seg    dw    0     ; current active segment
work2_seg   dw    0     ; second active segment
vbuffer     DW    0     ; address of video buffer segment
vid_len     DW    0     ; video screen length
vid_wid     DW    0     ; video screen width
vint       dw     0     ; video interlace used by basic bload routines
vphase      dw    0     ; phase of bload routines
xor_raw     db    0     ; switch which will inverse the raw read if 1
; tables for herc graphics
;
; error messages which can be displayed at end_prog
;
err1        db    'Feature not yet installed - I am working on it!',0
err2        DB    13,10,'Memory allocation error - Job cancelled',13,10,'$'
;
dseg        ENDS
            END
