; OKSCAN has the IX12, Princeton and JLASER routines in it
;
;LSEG	SEGMENT PUBLIC 'DATA'
;assume cs:cseg,ds:lseg,es:lseg
;ems_map1	dw 128 dup(0)
;ems_map2	dw 128 dup(0)
;LSEG	ENDS
;
EMS macro x
	mov	ah,x
	int	67h
	or	ah,ah
	endm
DSEG	SEGMENT PUBLIC 'DATA'
assume cs:cseg,ds:dseg,es:dseg
extrn left_margin:word,curx:word,cury:word,buffer:word,pass:word
extrn width_bytes:word,height_pix:word,vwid:word,scol:word,srow:word
extrn lcol:word,lrow:word,maxlines:word
extrn ems_free:word,ems_frame:word
extrn sneg:byte,ems_handle:word,work_seg:word,work2_seg:word
;
; this is the CAPCard bytes
capcard equ this byte
cap_x dw 0
cap_y dw 0
cap_width dw 0
cap_length dw 0
cap_di dw 0
cap_ds dw 0
cap_width1 dw 0
;
; local data
;
;
;
;IX-12 stuff
;
sred	db	0
sres	db	0
smod	db	0
sden	db	0
;
princeton	db	0	; princeton only flag
handy           db      0
;
; the following is for default setting informational messages
;
; =186 =187 =188 =200 =201 =205
line1	db	"The default Scanner Data has been",10
line3	db	"changed to:                             ",10
deftype equ line3+12
line4	db	"                                        ",10
defmess equ line4
	db	"    PRESS ANY KEY TO CONTINUE",0
;
err1	db	"The Scanner is not responding  ",10
	db	"    PRESS ANY KEY TO CONTINUE",0
;
;
err2	db	"An error occurred while scanning    ",10
	db	"    PRESS ANY KEY TO CONTINUE",0
;
mess1	db	"Prepare the paper and the scanner",10
	db	"    PRESS ANY KEY TO CONTINUE",0
;
mess2	db	"Move the pointer to the start location ",10
	db	"    (Alt-C to clear, Alt-I for Index)",0
;
err3	db	" No device driver could be found ",10
	db	"   PRESS ANY KEY TO CONTINUE",0
;
err6 equ this byte
e6line db	"                                         ", 10
	db	"  PRESS ANY KEY TO CONTINUE",0
;
err7	db	"You must specify a range and starting",10
	db	"position before you can scan or print.",10
	db	"     PRESS ANY KEY TO CONTINUE",0
;
err8	db	"  Wrong version Driver for IX-12.",10
	db	"  You must use the IXHND2 driver.",10
	db	"  PRESS ANY KEY TO CONTINUE",0
;
; =186 =187 =188 =200 =201 =205
msgparity	db 'Printer parity error       '
msgnocart	db 'Printer cartridge missing  '
msgjam	 	db 'Printer jam	               '
msgtest		db 'Printer busy test printing '
msgpaper	db 'Printer out of paper       '
msgnoprint	db 'Printer error - reprint    '
;
m1	db ' No Board error on scan     '
m2	db ' Time out on scanner        '
m4	db ' Overheat error on scan     '
m5	db ' Excessive paper length     '
m6	db ' Bad data length error      '
;
sredm	db        ' Horizontal Reduction Setting',0
sred1	db        'None',0
sred2	db        'One Half',0
sred3	db        'One Quarter',0
;
;
sresm	db        '  RESOLUTION',0
sres1	db        '75 DPI',0
sres2	db        '150 DPI',0
sres3	db        '200 DPI',0
sres4	db        '300 DPI',0
;
;
smodm	db        ' SCAN MODE',0
smod1	db        '2-value normal',0
smod2	db        '2-value or',0
smod3	db        'Dither',0
;
;
jsmodm	db        ' SCAN MODE',0
jsmod1	db        '2-value normal',0
jsmod2	db        '2-value or',0
jsmod3	db        'Bayer Dither',0
jsmod4	db        'Fatting Dither',0
;
;
sdenm	db        '  DENSITY CONTROL',0
sden1	db        'standard',0
sden2	db        'Dark',0
sden3	db        'Light',0
;
ux	dw	0
uy	dw	0
sx	dw	0
sy	dw	0
lx	dw	0
ly	dw	0
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  Handy Scanner Stuff
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;							;
;	There are three entries for user to program	;
;	the scanner :					;
;							;
;		1. scanner_pwr_on			;
;		2. line_scan				;
;		3. scanner_pwr_off			;
;							;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;							;
;	DMA channel 1 private parameters		;
;							;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
dma1_page_reg		equ	83H		; DMA channel 1 page register
dma1_address_reg	equ	2		; DMA channel 1 address reg.
dma1_counter_reg	equ	3		; DMA channel 1 counter reg.
dma1_mask_clear		equ	00000001b
dma1_mask_set		equ	00000101b
dma1_mode		equ	01000101b
dma1_request_clear	equ	00000001b
dma1_terminate_bit	equ	00000010b	; DMA channel 1 terminate bit
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;							;
;	DMA channel 3 private parameters		;
;							;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
dma3_page_reg		equ	82h		; DMA channel 3 page register
dma3_address_reg	equ	6		; DMA channel 3 address reg.
dma3_counter_reg	equ	7		; DMA channel 3 counter reg.
dma3_mask_clear		equ	00000011b
dma3_mask_set		equ	00000111b
dma3_mode		equ	01000111b
dma3_request_clear	equ	00000011b
dma3_terminate_bit	equ	00001000b	; DMA channel 3 terminate bit
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;							;
;	DMA I/O port and parameters			;
;							;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
dma_page_reg		dw	?
dma_address_reg		dw	?
dma_counter_reg		dw	?
dma_mask_clear		db	?
dma_mask_set		db	?
dma_mode		db	?
dma_request_clear	db	?
dma_terminate_bit	db	?
;
dma_status_reg		equ	08H	; 8237 DMAC STATUS REGISTER
dma_request_reg		equ	09H	; 8237 DMAC Request Register
dma_mask_reg		equ	0AH	; 8237 DMAC Mask Register
dma_mode_reg		equ	0BH	; 8237 DMAC Mode Register
dma_byte_ptr		equ	0CH	; 8237 internal Byte Pointer F/F
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;							;
;	 SCANNER I/O port				;
;							;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
scanner_pwr_port	equ	27ah	
scanner_status_port	equ	27bh
scanner_dreq_reset	equ	27ah
scanner_seq_reset	equ	27bh
;
;
DSEG ENDS
;
;
CSEG SEGMENT PUBLIC 'CODE'
assume cs:cseg,ds:dseg,es:dseg
extrn prbox_far:far,blip_far:far,blop_far:far,present_far:far,goback_far:far
extrn getkey_far:far,flush_buffer_far:far,do_wait_far:far,next_wait_far:far
extrn reset_segs_far:far,first_range_far:far,set_range_far:far
extrn fill_buffer_far:far,calc_file_size_far:far,get_curr_seg_far:far
extrn get_curr2_seg_far:far
extrn cc_setup_far:far,blip_far:far
;
do_sstart:
 public do_sstart
   call  far ptr do_sstart_far
   ret
do_srange:
 public do_srange
   call  far ptr do_srange_far
    ret
do_scan:
public do_scan
   call  far ptr do_scan_far
   ret
do_handy:
public do_handy
   call far ptr do_handy_far
   ret
do_princeton:
public do_princeton
   call  far ptr do_princeton_far
   ret
do_cap:
public do_cap
   call  far ptr do_cap_far
   ret
;
;
scan_procs proc	near
set_sred1:
	mov	sred,0
	lea	si,sredm
	lea	di,sred1
	jmp	pmess
set_sred2:
	mov	sred,40h
	lea	si,sredm
	lea	di,sred2
	jmp	pmess
set_sred3:
	mov	sred,80h
	lea	si,sredm
	lea	di,sred3
	jmp	pmess
set_sres1:
	mov	sres,00h
	lea	si,sresm
	lea	di,sres1
	jmp	pmess
set_sres2:
	mov	sres,10h
	lea	si,sresm
	lea	di,sres2
	jmp	pmess
set_sres3:
	mov	sres,20h
	lea	si,sresm
	lea	di,sres3
	jmp	pmess
set_sres4:
	mov	sres,30h
	lea	si,sresm
	lea	di,sres4
	jmp	pmess
set_smod1:
	mov	smod,00h
	lea	si,smodm
	lea	di,smod1
	jmp	pmess
set_smod2:
	mov	smod,04h
	lea	si,smodm
	lea	di,smod2
	jmp	pmess
set_smod3:
	mov	smod,08h
	lea	si,smodm
	lea	di,smod3
	jmp	pmess
set_sden1:
	mov	sden,00h
	lea	si,sdenm
	lea	di,sden1
	jmp	pmess
set_sden2:
	mov	sden,01h
	lea	si,sdenm
	lea	di,sden2
	jmp	pmess
set_sden3:
	mov	sden,02h
	lea	si,sdenm
	lea	di,sden3
	jmp	pmess
	ret
public set_sres1,set_sden1,set_smod1,set_sred1
public set_sres2,set_sden2,set_smod2,set_sred2
public set_sres3,set_sden3,set_smod3,set_sred3
public set_sres4
scan_procs endp
;
;
pmess	proc near
; the pmess proc prints out the message that the default has been
; changed.
; the change message is in si, the type change is in di
	push	si
	push	di
; clear out the message
	lea	di,defmess
	mov	cx,38
	cld
	mov	al,' '
rep	stosb
	lea	di,deftype
	mov	cx,25
	cld
	mov	al,' '
rep	stosb
; now move in the type change
	pop	si
	lea	di,deftype
	mov	cx,28
dt_loop:
	lodsb
	cmp	al,0
	je	end_dt
	stosb
	loop	dt_loop
end_dt:
; now move in the defmess
	pop	si
	lea	di,defmess
	mov	cx,38
dm_loop:
	lodsb
	cmp	al,0
	je	end_dm
	stosb
	loop	dm_loop
end_dm:
extrn prbox:near,getkey:near,blip:near,present:near,goback:near
; print the message
	mov	left_margin,64
	mov	curx,64
	mov	cury,48
	lea	dx,line1
	call 	prbox
	call 	getkey
	call 	blip_far
	call 	present
	mov	left_margin,0
	call 	goback
	ret
pmess	endp
;
;
CSEG ENDS
;xyzzy
; first_range_far
; set_range_far
; calc_file_size_far
; cc_setup_far
; do_wait_far
; next_wait_far
; flush_buffer_far
; blop_far
; fill_buffer_far
CSEG2 SEGMENT PUBLIC 'TEXT'
assume cs:cseg2,ds:dseg,es:dseg
do_sstart_far proc far
	call far ptr	present_far
	mov	left_margin,64
	mov	curx,64
	mov	cury,40
	lea	dx,mess2
	call far ptr	prbox_far
	call far ptr	first_range_far
	cmp	al,27
	jne	got_first_range_far
	call far ptr	present_far
	ret
got_first_range_far:
	mov	ax,scol
	mov	ux,ax
	mov	ax,srow
	mov	uy,ax
	call far ptr	present_far
	ret
do_sstart_far endp
;
do_srange_far	proc	far
	call far ptr	set_range_far
	cmp	al,27
	jne	ok_srange
	call far ptr	present_far
	ret
ok_srange:
	mov	ax,srow
	mov	sy,ax
	mov	ax,scol
	mov	sx,ax
	mov	ax,lcol
	mov	lx,ax
	mov	ax,lrow
	mov	ly,ax
	call far ptr	present_far
	ret
do_srange_far endp
;
;
;
setup_scan_far	proc	near
; begin the scan
; first set the scan mode and check to see if the scanner is there
;
;
	call far ptr	reset_segs_far
	call far ptr present_far
	mov	ax,sy
	mov	srow,ax
	mov	ax,sx
	mov	scol,ax
	mov	ax,lx
	mov	lcol,ax
	mov	ax,ly
	mov	lrow,ax
;
;
;
	mov	ax,sx
	cmp	ax,lx
	jne	good_range
bad_range:
	lea	dx,err7
	jmp error1
good_range:
	mov	ax,lx
	mov	ax,sy
	cmp	ax,ly
	je	bad_range
	call far ptr	calc_file_size_far
	call far ptr	cc_setup_far
        cmp     handy,1
        jne     nh_4
	mov	ax,width_bytes          ; width to transfer
        cmp     ax,250                 ; widest handy scanner
        jle     hs_4
        mov     ax,250
hs_4:
        mov   width_bytes,ax
        ret
nh_4:
	mov	ax,79
	mov	bx,877
	cmp	sres,10h
	jne	not_sres10
	mov	ax,159
	mov	bx,1754
not_sres10:
	cmp	sres,20h
	jne	not_sres20
	mov	ax,212
	mov	bx,2339
not_sres20:
	cmp	sres,30h
	jne	not_sres30
	mov	ax,318
	mov	bx,3508
not_sres30:
; now	set up the height_pix and width_bytes
	cmp	ax,width_bytes
	jle	ok_width_bytes
	mov	width_bytes,ax
ok_width_bytes:
	cmp	bx,height_pix
	jle	ok_height_pix
	mov	height_pix,bx
ok_height_pix:
	ret
setup_scan_far	endp
;
;
;
;
;
do_scan_far	proc far
	mov	princeton,0
        mov     handy,0
	jmp	begin_scan
label do_princeton_far far
	mov	princeton,1
        mov     handy,0
	jmp	begin_scan
label do_handy_far far
	mov	princeton,0
        mov     handy,1
begin_scan:
	call far ptr	setup_scan_far
        cmp     handy,1
        jne     nh_1
; initialize handy scanner
	call far ptr	scanner_pwr_on		; Turn on the scanner
	jc	scanner_hw_error
        jmp     got_settings
nh_1:
; check to see if the 7f interrupt really does exist
;
	push	es
	mov	ax,0
	mov	es,ax
	mov	bx,(7fh*4)+2
	cmp	word ptr es:[bx],0
	pop	es
	jne	ok_int
	lea	dx,err3
	jmp error1
ok_int:
	mov	pass,0
	mov	ah,0
	mov	al,-1
	int	7fh
	cmp	al,0
	jge	got_board
scanner_hw_error:
	lea	dx,err1
	jmp	error1
got_board:
	cmp	princeton,1
	je	got_board2
	mov	ah,10
	mov	al,0
	int	7fh
	cmp	al,0
	jge	got_board2
	lea	dx,err8
	jmp	error1
got_board2:
; the board answered
;
;	set the input parameter settings
	mov	ah,1
	mov	al,sred
	or	al,sres
	or	al,smod
	or	al,sden
	mov	dx,3
	mov	cx,width_bytes
	shl	cx,1
	shl	cx,1
	shl	cx,1
	mov	bx,ux
	shl	bx,1
	shl	bx,1
	shl	bx,1
	int	7fh
	cmp	al,0
	jge	got_settings
	lea	dx,err1
	jmp	error1
got_settings:
; now we have to set up a loop to read the data
;
	lea	dx,mess1
	mov	left_margin,64
	mov	curx,64
	mov	cury,48
	call far ptr	prbox_far
	call far ptr	getkey_far
;
	cmp	al,27
	jne	next_phase
	call far ptr	goback_far
next_phase:
	call far ptr	reset_segs_far
	call far ptr	do_wait_far
	mov	pass,0
        cmp     handy,1
        je      start_scanning  ; bypass paper advance
; now advance the paper a few lines
	cmp	uy,0
	je	start_scanning
	mov	cx,uy
skip_loop:
	push	cx
	mov	ah,3
	mov	al,0
	int	7fh
	pop	cx
	loop	skip_loop
start_scanning:
; scan loop
	call far ptr	reset_segs_far
	mov	dx,0
	mov	bx,0
	mov	cx,height_pix
	mov	es,buffer
	mov	di,0
	mov	bp,0
scan_loop:
	push	bp
	push	cx
	push	di
        push    es
	call far ptr	cinput
	jc	end_scan
cont_scan:
        pop     es
	pop	di
	add	di,width_bytes
	call far ptr	do_negate
        push    cx
	push	di
	push	es
	call far ptr	next_wait_far
	mov	cx,di
;
	call far ptr	reset_segs_far
	push	si
	push	bp
	call far ptr	flush_buffer_far
	pop	si
	pop	bp
by_cflush:
;
;
	pop	es
	pop	di
        pop     cx
	jnc	by_flush1a
	mov	di,0
	call far ptr	reset_segs_far
	pop	cx
	pop	bp
	jmp	end_scan
by_flush1a:
	mov	di,0
by_flush1:
; check for a keystroke
;
	mov	ah,1
	int	16h
	jz	no_key_pressed
	mov	ah,0
	int	16h	; get the key
	cmp	al,27
	jne	by_flush1
	pop	cx
	pop	bp
	call far ptr	blip_far
	call far ptr	blop_far
	call far ptr	blip_far
	jmp	end_scan
no_key_pressed:
;
	pop	cx
	pop	bp
	inc	bp
	loop	scanloopx
	jmp	end_scan
scanloopx:
	jmp	scan_loop
end_scan:
	cmp	di,0
	je	by_flush2
	mov	cx,di
c_flush2:
	call far ptr	flush_buffer_far
by_flush2:
        cmp     handy,1
        jne     nh_2
; turn off the scanner
	call far ptr	scanner_pwr_off		; Turn off the scanner
nh_2:
	call far ptr	blip_far
	call far ptr	blip_far
	call far ptr	present_far
	call far ptr	goback_far
bad_scan:
	lea	dx,err2
	jmp	error1
do_scan_far	endp
;
;	canon scanner input routine
;
cinput proc far
        cmp     handy,1
        jne     nh_3
; do scan, di points to scan
	call far ptr	line_scan		; To read one scan line to ES:DI
	clc
	ret
nh_3:
	mov	ah,2
	mov	al,1
	mov	cx,0
	mov	bx,0
	mov	dx,3
	int	7fh
	cmp	ax,0
	jl	no_cont_scan
	clc
	ret
no_cont_scan:
	cmp	ax,-3
	jne	con_scan_error
	stc
	ret
con_scan_error:
; an error occured
;
	mov	si,offset m1
	cmp	ax,-1	; no board
	je	doer1
	cmp	ax,-2	;
	mov	si,offset m2
	je	doer1
	cmp	ax,-4	;
	mov	si,offset m4
	je	doer1
	cmp	ax,-5	;
	mov	si,offset m5
	je	doer1
	cmp	ax,-6	;
	mov	si,offset m6
	je	doer1
doer1:
	lea	di,e6line+8
	mov	cx,26
	cld
rep	movsb
	lea	di,err6
;	jmp error1
error1:
; print the message
	push	dx
	call far ptr	present_far
	call far ptr	reset_segs_far
	mov	left_margin,64
	mov	curx,64
	mov	cury,48
	pop	dx
	call far ptr	prbox_far
	call far ptr	getkey_far
	call far ptr	blip_far
	call far ptr	present_far
	mov	left_margin,0
	call far ptr	goback_far
cinput endp
;
do_negate proc far
; this assumes that es:di points to the end of the area just scanned
	push	ds
	push	di
	push	cx
	push	ax
	push	es
	call far ptr	reset_segs_far
	cmp	sneg,1
	jne	exit_negate
	pop	es
	push	es
	sub	di,width_bytes
	mov	cx,width_bytes
neg_loop:
	xor	byte ptr es:[di],0ffh
	inc	di
	loop	neg_loop
exit_negate:
	pop	es
	pop	ax
	pop	cx
	pop	di
	pop	ds
	ret
do_negate endp
;
;
do_cap_far proc far
; this is really the same as writing out a file
; we need to get the output data set up
	call far ptr	reset_segs_far
	mov	sres,30h
	call far ptr	setup_scan_far
	mov	ax,ux
	mov	cap_x,ax
	mov	ax,uy
	mov	cap_y,ax
;
; now we have to set up a loop to read the data
;
	call far ptr	do_wait_far
; get a buffer full of data
	call far ptr	fill_capp	; get a buffer from the screen
	jnc	good_cread
	jmp	end_cap
good_cread:
	call far ptr	reset_segs_far
; ax and cx return with the amount of data in the buffer
	mov	bp,ax
	mov	cx,height_pix
	cld
capp_loop:
	push	cx
	push	bp
	push	di
; bp now has the line number we are working on
	mov	cx,width_bytes
; the line to get must be in bp
;	do the thing
; data returns in dx:si
	mov	ax,buffer
	mov	cap_ds,ax
	mov	cap_di,di
	mov	cap_width,cx
	mov	cap_width1,cx
	mov	cap_length,1
	mov	ax,ux
	mov	cap_x,ax
	inc	cap_y
	mov	cx,ds
	lea	bx,capcard
	mov	ah,10h
	mov	al,47
	mov	dx,-1
	int	17h
;
	pop	di
	pop	bp
	add	di,width_bytes
	sub	bp,width_bytes ; reduce count of bytes left
	cmp	bp,0
	jg	good_cbp
	call far ptr	fill_capp
	jc	end_cap
good_cbp:
	pop	cx
	loop	capp_loop
end_cap:
	call far ptr	reset_segs_far
	call far ptr	blip_far
	call far ptr	present_far
	call far ptr	goback_far
fill_capp:
; get some more lines for the loop
	push	ds
	push	es
	call far ptr	reset_segs_far
	mov	ax,buffer
	mov	es,ax
	mov	ds,ax
	call far ptr	fill_buffer_far
	call far ptr	reset_segs_far
;
; get the page map back for us
	push	ax
	call far ptr	next_wait_far
	pop	ax
	pop	es
	pop	ds
	mov	di,0
	cmp	ax,0
	je	fill_badc
	mov	bp,ax
	clc
	ret
fill_badc:
	stc
	ret
do_cap_far endp
handy_stuff proc far
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;							;
;	This subroutine read one scan line 64 bytes	;
;	into the address specified by ES:DI		;
;							;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
line_scan:
	call far ptr	dma_mode_setup		; setup the dma transfer mode
	call far ptr	dma_page_setup		; setup the dma page register
	call far ptr	dma_address_setup	; setup the dma address register
	call far ptr	dma_counter_setup	; setup the dma counter register
	call far ptr	scanner_init		; initial the scanner
	call far ptr	start_dma		; start dma data transfer
	call far ptr	dma_end_check		; check the transfer complete
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;							;
;	This subroutine setup the paraters of the 	;
;	dma channel for following dma operation.	;
;	If the dma jumper setting is invalid the	;
;	carry bit will be set on return, otherwise	;
;	the carry bit is cleared.			;
;							;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
dma_parameter_setup:
	push	ax
	push	dx
	mov	dx,scanner_status_port
	in	al,dx
	or	al,11110101b
	cmp	al,11111101b	; check for dma channel 1
	je	dma1_in_use
	cmp	al,11110111b	; check for dma channel 3
	je	dma3_in_use
	pop	dx
	pop	ax
	stc			; invalid dma setting
	ret
dma1_in_use:
	mov	dma_page_reg,dma1_page_reg
	mov	dma_address_reg,dma1_address_reg
	mov	dma_counter_reg,dma1_counter_reg
	mov	dma_mask_clear,dma1_mask_clear
	mov	dma_mask_set,dma1_mask_set
	mov	dma_mode,dma1_mode
	mov	dma_request_clear,dma1_request_clear
	mov	dma_terminate_bit,dma1_terminate_bit
	pop	dx
	pop	ax
	clc
	ret
dma3_in_use:
	mov	dma_page_reg,dma3_page_reg
	mov	dma_address_reg,dma3_address_reg
	mov	dma_counter_reg,dma3_counter_reg
	mov	dma_mask_clear,dma3_mask_clear
	mov	dma_mask_set,dma3_mask_set
	mov	dma_mode,dma3_mode
	mov	dma_request_clear,dma3_request_clear
	mov	dma_terminate_bit,dma3_terminate_bit
	pop	dx
	pop	ax
	clc
	ret
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;							;
;	This subroutine setup the dma transfer mode	;
;							;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
dma_mode_setup:
	push	ax
	push	dx
	mov     al,dma_mask_set
	mov	dx,dma_mask_reg		; Set dma mask bit to
	out     dx,al			;	disable dma transfer
	call far ptr    dummy			; Dummy time delay
	mov	al,dma_mode		;
	mov	dx,dma_mode_reg		; set the dma transfer mode :
	out	dx,al			;	. memory write, I/O read
					;	. auto-initialization disable
					;	. address increment
					;	. single mode
	pop	dx
	pop	ax
	ret
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;								;
;	This subroutine setup the dma page register		;
;	The 4-bit page register holds the 4 most significant	;
;	bits of the 20 bit physical address ES:DI		;
;								;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
dma_page_setup:
	push	ax
	push	cx
	push	dx
	mov	cl,4
	mov	ax,di
	shr	ax,cl			; Shift DI 4 bit left
	mov	cx,es
	add	ax,cx			; Add ES
	mov	cl,12
	shr	ax,cl			; Shift the sum 12 bit left
	and	ax,0fh			; Clear the undesired bits
	mov	dx,dma_page_reg
	out	dx,al			; Output to dma page register
	pop	dx
	pop	cx
	pop	ax
	ret
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;								;
;	This subroutine setup the dma address register.		;
;	The 16-bit address register inside the 8237 holds the	;
;	16 least significant bits of the 20 bit physical	;
;	address ES:DI						;
;	The address register is 16 bits wide, only one I/O port	;
;	is assigned for the address register. Two consecutive	;
;	output instructions are required to setup the 16-bit	;
;	address register.					;
;								;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
dma_address_setup:
	push	ax
	push	cx
	push	dx
	mov	ax,es			; To calculate the 16 least
	mov	cl,4			; significant bits of ES:DI
	shl	ax,cl
	add	ax,di
	mov	dx,dma_byte_ptr		; To clear the 8237 internal
	out	dx,al			; byte pointer F/F to make sure that
					; the following transfer is from
					; low byte. The data in AL is meanless
	call far ptr	dummy
	mov	dx,dma_address_reg
	out	dx,al			; Output the low byte of address reg.
	call far ptr	dummy
	mov	al,ah
	out	dx,al			; Output the hi byte of address reg.
	pop	dx
	pop	cx
	pop	ax
	ret
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;								;
;	This subroutine setup the dma counter register.		;
;	The 16-bit counter register inside the 8237 holds the	;
;	the total number of bytes to be transferred minus 1.	;
;	CX : The total number to be transferred.		;
;	The counter register is 16 bits wide, only one I/O port	;
;	is assigned for the counter register. Two consecutive	;
;	output instructions are required to setup the 16-bit	;
;	address register.					;
;								;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
dma_counter_setup:
	push	ax
	push	cx
	push	dx
	mov	dx,dma_byte_ptr		; To clear the 8237 internal
	out	dx,al			; byte pointer F/F to make sure that
					; the following transfer is from
					; low byte. The data in AL is meanless
	call far ptr	dummy
	mov	cx,width_bytes          ; width to transfer
	dec	cx
	mov	al,cl
	mov	dx,dma_counter_reg
	out	dx,al			; Output the low byte of counter reg.
	call far ptr	dummy
	mov	al,ch
	out	dx,al			; Output the hi byte of address reg.
	pop	dx
	pop	cx
	pop	ax
	ret
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;								;
;	This subroutine start the dma transfer			;
;								;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
start_dma:
	push	ax
	push	dx
	mov	dx,dma_request_reg
	mov	al,dma_request_clear
	out	dx,al			; Clear 8237 internal request bit
	call far ptr	dummy
	mov	dx,dma_mask_reg
	mov	al,dma_mask_clear	; Clear dma mask bit to 
	out	dx,al			; enable dma transfer
	pop	dx
	pop	ax
	ret
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;							;
;	This routine waiting for dma transfer complete	;
;							;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
dma_end_check:
	push	ax
	push	dx
end_check_loop:
        mov    ah,1
        int    16h
        jnz    end_check
	mov	dx,dma_status_reg
	in	al,dx
	and	al,dma_terminate_bit
	cmp	al,dma_terminate_bit
	jne	end_check_loop
end_check:
	pop	dx
	pop	ax
	ret
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;							;
;	This is dummy routine for time consumption	;
;							;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
dummy:
	nop
	nop
	nop
	ret
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;							;
;	This subroutine turns the scanner power on	;
;							;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
scanner_pwr_on:
	push	ax
	push	dx
	mov	dx,scanner_pwr_port
	mov	al,1
	out	dx,al
	pop	dx
	pop	ax
	call far ptr	dma_parameter_setup
	ret
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;							;
;	This subroutine turns the scanner power off	;
;							;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
scanner_pwr_off:
	push	ax
	push	dx
	mov	dx,scanner_pwr_port
	mov	al,0
	out	dx,al
	pop	dx
	pop	ax
	ret
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;							;
;	This subroutine initial the scanner H/W		;
;							;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
scanner_init:
	push	ax
	push	dx
	mov	dx,scanner_seq_reset	; Output a dummy data to port 
	out	dx,al			; scanner_seq_reset to reset the
					; on board sequencer
	mov	dx,scanner_dreq_reset	; A dummy input from port
	in	al,dx			; scanner_dreq_reset to clear the
					; on board dma request bit
	pop	dx
	pop	ax
	ret
handy_stuff  endp
;
;
;
;
CSEG2 ENDS
	END
