dseg segment para public 'DATA'
     assume ds:dseg
     extrn tone_on:byte
dseg ends
cseg        SEGMENT PARA PUBLIC 'CODE'
; the tone routines produce glisandos based on the value of si
ASSUME      CS:cseg,ds:dseg
PUBLIC      blip,blop
blip        PROC  NEAR
            cmp   tone_on,0
            je   do_blip
            ret
do_blip:
            PUSH  SI
            MOV   SI,30
            CALL  tone
            POP   SI
            RET
blip        ENDP
blop        PROC  NEAR
            cmp   tone_on,0
            je   do_blop
            ret
do_blop:
            PUSH  SI
            MOV   SI,-30
            CALL  tone
            POP   SI
            RET
blop        ENDP
tone        PROC  NEAR
            PUSH  AX
            PUSH  BX
            PUSH  CX
            PUSH  DX
            MOV   DX,3        ; tone rate
            MOV   BX,240      ; starting freq
            MOV   CX,750      ; ending frequency
            CMP   SI,0
            JG    do_blipp
; here we do blop
            MOV   BX,630      ; starting freq
            MOV   CX,150      ; ending frequency
do_blipp:
; turn on tone
i0:
            PUSH  CX
            PUSH  BX
            IN    AL,61h
            OR    AL,3
            OUT   61h,AL
; loop parameters
            MOV   CX,BX
; set frequency
            MOV   DX,12h
            MOV   AX,34deh
            DIV   CX
            MOV   CX,AX
; set tone
            MOV   AL,CL
            OUT   42h,AL
            MOV   AL,CH
            OUT   42h,AL
i2:         LOOP  i2
            POP   BX
            POP   CX
            CMP   BX,CX
            JE    ip3
            ADD   BX,SI
            JMP   i0
ip3:
;turn off tone
            IN    AL,61h
            AND   AL,11111100b
            OUT   61h,AL
            POP   DX
            POP   CX
            POP   BX
            POP   AX
            RET
tone        ENDP
cseg        ENDS
            END
