; OKSCREEN.ASM sets screen attributes and checks for screen types
;
;
segmentsize	equ	8000h
;
dseg	SEGMENT PUBLIC 'DATA'
extrn	last_si:word,last_seg:word,vwid:word,tot_mem:word
extrn	last_fsi:word,last_fseg:word
EXTRN	mode:BYTE,vbuffer:WORD,vid_wid:WORD,vid_len:WORD,interlace:WORD
EXTRN	entry_mode:BYTE
EXTRN	color:BYTE,palette:BYTE
EXTRN	gtable:BYTE,attcopy:BYTE,default_mode:BYTE,ttable:BYTE
extrn	ems_allocated:word,planes:word,plane_switch:byte
extrn	color_map:byte
extrn   egavga:byte
planesa db 0
public planesa
;
video struc
axreg   dw ?
bxreg   dw ?
dwidth  dw ?
dlen    dw ?
dint    dw ?
dbuff   dw ?
dplanes dw ?
        dw ?   ; growth
video  ends
;
vlist  equ this byte
video <0004h,000h,320,100,2,0b800h,1,0>; - cga med
video <0006h,000h,640,100,2,0b800h,1,0>; - cga high
video <0053h,000h,640,560,1,0a000h,4,0>; - vip53
video <0059h,000h,720,512,1,0a000h,4,0>; - gen59
video <0073h,000h,640,480,1,0a000h,4,0>; - gen73
video <007ch,000h,512,512,1,0a000h,4,0>; - gen7c
video <0011h,000h,640,480,1,0a000h,4,0>; - vag11
video <0012h,000h,640,480,1,0a000h,4,0>; - vga12
video <0013h,000h,320*8,200,1,0a000h,4,0>; - vga13
video <0025h,000h,640,480,1,0a000h,4,0>; - setnec
video <0050h,000h,640,480,1,0a000h,4,0>; - setpara * 10
video <000fh,000h,640,350,1,0a000h,4,0>; - setega 0f
video <0010h,000h,640,350,1,0a000h,4,0>; - setega 10
video <005eh,000h,800,600,1,0a000h,4,0>; - ATI Prism *13
video <0054h,000h,800,600,1,0a000h,4,0>; - ATI vga wonder
video <0070h,002h,800,600,1,0a000h,4,0>; - Everex EV-673
video <0040h,000h,640,100,4,0b800h,1,0>; - at&t *16
video <0029h,000h,800,600,1,0a000h,4,0>; - gen5200
video <005eh,000h,800,600,1,0a000h,4,0>; - logix
video <005bh,000h,800,600,1,0a000h,4,0>; - maxon
video <0029h,000h,800,600,1,0a000h,4,0>; - orchid *20
video <0058h,000h,800,600,1,0a000h,4,0>; - para pro
video <6f05h,0060h,752,410,1,0a000h,4,0>; - video 7
video <6f05h,0061h,720,540,1,0a000h,4,0>; - video 7
video <6f05h,0062h,800,600,1,0a000h,4,0>; - video 7*24
;
;

vesablock db 'XXXX'
vversion  dw 0
oemstring dd 0
cap       db 0,0,0,0
vidmodes  dd 0
vesamode  dw 0
curbk    dw 0
public vesamode

;
dseg	ENDS
cseg	segment PUBLIC 'CODE'
	assume	CS:cseg,DS:dseg,ES:dseg
PUBLIC	do_herc,do_att,do_640,do_vesa
PUBLIC	set_color,set_palette,set_screen,calc_last

dovid  macro cnt,vid,pub
set&pub:
    mov   si,16*cnt
    jmp   set_standard&vid
do_&pub:
public do_&pub
   CALL	set&pub
   CALL	quit
   RET
   endm
 
dovid 0,,med
dovid 1,,hires
dovid 2,ega,vip53
dovid 3,ega,gen59
dovid 4,ega,gen73
dovid 5,ega,gen7c
dovid 6,vga,vga11
dovid 7,vga,vga12
dovid 8,vga,vga13
dovid 9,ega,nec
dovid 10,ega,para480
dovid 10,ega,tseng
dovid 11,ega,ega0f
dovid 12,ega,ega10
dovid 13,vga,atiprism
dovid 14,vga,vgawonder
dovid 15,vga,ev673
dovid 16,,tosh3100
dovid 16,att,att
dovid 16,,compaq
dovid 17,vga,gen5200
dovid 18,vga,logix
dovid 19,vga,maxxon
dovid 20,vga,orchid
dovid 21,vga,parapro
dovid 22,vga,v760
dovid 23,vga,v761
dovid 24,vga,v762
set_standardatt:
     call  checkatt
     jnc   set_standard
     ret
set_standardvga:
     call  check_vga
     jnc   set_standard
     ret
set_standardega:
     call  check_ega
     jnc   set_standard
     ret
set_standard:
; sets standard modes
    mov  planes,1
    mov  ax,vlist[si].dplanes
    mov  planesa,al
    mov  ax,vlist[si].axreg
    MOV	 mode,al
    mov  ax,vlist[si].dbuff
    mov  vbuffer,ax
    mov  ax,vlist[si].dwidth
    shr  ax,1
    shr  ax,1
    shr  ax,1
    MOV  vid_wid,ax
    mov  ax,vlist[si].dlen
    MOV  vid_len,ax
    mov  ax,vlist[si].dint
    mov  interlace,ax
    CALL set_simode
    DEC  color
    DEC  palette
    cmp  vbuffer,0b800h
    je   do_scolor
    clc
    ret
do_scolor:
;   CALL set_color
;   CALL set_palette
    mov  egavga,0
    clc
    RET
; modes are as follows:
detect proc near
; this returns in al the best possible video mode
; routine is:
; 1) check for VGA
; 2) check for EGA
; 3) check for AT&T
; 4) check for HERC
; 5) check for CGA
;	if VGA or EGA find the kind of monitor that's hooked up
; check first for at&t
       call checkatt
       jc    no_att_found
       mov   al,40h
       ret
no_att_found:
; check for vesa
        call   checkvesa
        jc     aint_vesa
; return with al = -1, vesa mode is set
        ret
aint_vesa:
	mov	ax,1a00h
	int	10h
	cmp	al,1ah
	jne	aint_vga
	mov	ax,1a01h
	int	10h
	cmp	al,1ah
	jne	aint_vga
	cmp	bl,1
	je	its_vga
	cmp	bl,3
	jle	its_cga
	cmp	bl,5
	jle	its_ega
its_vga:
; now check if we are in mono or color
    mov  egavga,1
	mov	al,12h
;	cmp	entry_mode,7
;	jne	aint_vga_m
;	mov	al,0eh
aint_vga_m:
	ret
its_ega:
	mov	al,10h
	cmp	entry_mode,7
	jne	aint_ega_m
    mov  egavga,1
	mov	al,0eh
aint_ega_m:
	ret
its_cga:
    mov  egavga,0
	mov	al,6
	ret
aint_vga:
	mov	ax,1200h
	mov	bl,10h
	int	10h
	cmp	bl,10h
	je	aint_ega
; find out who's attached
	mov	ax,1210h ; get switches
	int	10h
	cmp	bl,3 ; ega memory
	jl	its_cga
	and	cl,15
	test	cl,1
	jnz	its_ega
	cmp	cl,8
	je	its_ega
	jmp	its_cga
aint_ega:
; now test for AT&T
	call	checkatt
	jc	aint_att
	mov	al,40h
    mov  egavga,0
	ret
aint_att:
; check for herc
	call	check_herc
	Jc	aint_herc
    mov  egavga,0
	mov	al,43h
	ret
aint_herc:
; must be jam cause jelly don't shake like that
	jmp	its_cga
detect endp
EXTRN	quit:NEAR,reset_segs:near,blip:near
screens	dw	0,no_default
	dw	4,setmed
	dw	6,sethires
	dw	8,do_genius
	dw	15,setega0f
	dw	16,setega10
	dw	17,setvga11
	dw	18,setvga12
	dw	25h,setnec
	dw	40h,setatt
	dw	43h,setherc
	dw	50h,setpara480
	dw	53h,setvip53
	dw	59h,setgen59
	dw	73h,setgen73
	dw	74h,settosh3100
	dw	7ch,setgen7c
	dw	88h,set640
        dw      52h,setev673
        dw      54h,setvgawonder
        dw      5eh,setatiprism
        dw      0ffh,setvesa
	dw	0ffffh,0	; stopper
set_screen	PROC	NEAR
; attempts to set the proper screen
	call	reset_segs
	lea	si,cs:screens
	mov	bl,default_mode
	mov	bh,0
	cmp	bx,0
	je	no_default
	cld
try_mode:
	mov	ax,cs:[si]
	inc	si
	inc	si
	cmp	ax,bx
	je	do_mode
	cmp	ax,0ffffh
	je	no_default
	inc	si
	inc	si
	jmp	try_mode
do_mode:
	call	cs:[si]
	ret
no_default:
	call	detect
	mov	default_mode,al
	jmp	set_screen
set_screen	ENDP
set_simode:
     push  si
     mov   ax,vlist[si].axreg
     mov   bx,vlist[si].bxreg
     int   10h
     pop   si
; set color map
        cmp  vlist[si].dplanes,1
        je   ssmode1
    mov  egavga,1
	lea	dx,color_map
	mov	ah,10h	; set pallette
	mov	al,2
	int	10h
     cmp   plane_switch,4
     jne   ssmode1
        mov  ax,vlist[si].dplanes
	mov	planes,ax
ssmode1:
	call	calc_last
     ret
set_mode:
; just issues interrupt 10h to make sure bios knows our mode
        mov  planesa,1
;
	MOV	AH,0
	MOV	AL,mode
        cmp     al,-1
        je      no_vmode
	INT	10h
no_vmode:
	mov	planes,1
	cmp	egavga,1
	jne	one_plane
	mov	al,plane_switch
	mov	ah,0
	mov	planes,ax
; set color map
	lea	dx,color_map
	mov	ah,10h	; set pallette
	mov	al,2
	int	10h
one_plane:
	call	calc_last
	RET
do_genius:
public do_genius
	MOV	mode,8
	MOV	vbuffer,0a000h
	MOV	vid_wid,91
	MOV	vid_len,512
	MOV	interlace,1
	CALL	set_mode
; place board in mds mode
	mov	dx,3b0h
	mov	al,01h
	out	dx,al
; have to turn off text
	mov	dx,03b8h
	mov	al,0
	out	dx,al
; have to turn on graphics
	mov	dx,03d8h
	mov	al,8
	out	dx,al
	CLC
	RET
set640	PROC	NEAR
; this sets the amdek 640	mode
	MOV	AL,088h	;640x400 mode even bank
	MOV	DX,3dfh	; native ocntrol port
	OUT	DX,AL
; set the start addresses to 0 for each bank
	MOV	AL,0
	MOV	DX,3ddh
	OUT	DX,AL
	MOV	AL,0
	MOV	DX,3deh
	OUT	DX,AL
; set the vid and other parameters
	MOV	mode,088h
	MOV	vbuffer,0a000h
	MOV	vid_wid,80
	MOV	vid_len,400
	MOV	interlace,1
	CALL	set_mode
	RET
set640	ENDP
unam	PROC	NEAR
	CMP	mode,88h
	JNE	not_am_640
	CALL	un640
not_am_640:
	RET
unam   endp
un640	PROC	NEAR
; the amdek is the only mode that has to be undone
	MOV	AL,80h	;1280x800 mode even bank undo
	MOV	DX,3dfh	; native ocntrol port
	OUT	DX,AL
	RET
un640	ENDP
setherc	PROC	NEAR
; this will only go into herc graphics if the entry_mode is 7
	call	check_herc
	Jnc	got_herc
	RET
got_herc:
	mov	planes,1
	MOV	mode,43h
	MOV	vbuffer,0b000h
	MOV	vid_wid,90
	MOV	vid_len,87
	MOV	interlace,4
	CALL	set_mode
	call	reset_segs
	CALL	hgmode
	call	reset_segs
	CLC
	RET
setherc	ENDP
check_vga	proc near
; this checks to see of the VGA is present by doing a vga only
; call and sets the carry flag accordingly
	mov	ax,1a00h
	int	10h
	cmp	al,1ah
	jne	no_vga
	clc
	ret
no_vga:
	stc
	ret
check_vga	endp
check_herc	proc near
; this does a check to see if hercules mode is possible
; ega and vga must have failed before this is attempted
	mov	bx,0b000h	; mono segment
	push es
	mov	es,bx
	mov	ax,word ptr es:[7000] ; if ordinary mono does not exist
	mov	cx,01010101b
	mov	word ptr es:[7000],cx
	cmp	word ptr es:[7000],cx
	jne	not_hercules
	xor	word ptr es:[7000],cx
	xor	cx,cx
	cmp	word ptr es:[7000],cx
	jne	not_hercules
	mov	word ptr es:[7000],"ho"
	cmp	word ptr es:[7000],"ho"
	jne	not_hercules
	mov	word ptr es:[7000],ax
	pop	es
	clc
	ret
not_hercules:
	pop	es
	stc
	ret
check_herc	endp
check_ega	proc	near
; this does a check for ega and sets carry if not present
; this will only work if the EGA is present
	MOV	AX,1200h
	MOV	BX,10h
	MOV	CX,0ffffh
	INT	10h
	CMP	CX,0ffffh
	JNE	there_is_ega
	STC
	RET
there_is_ega:
	clc
	ret
check_ega	endp
checkatt proc near
        push    cx
        push    si
        push    di
	PUSH	ES
	MOV	AX,0fc00h
	MOV	ES,AX
	MOV	DI,40h
	CLD
	MOV	AL,28h
	MOV	CX,32
REPNE	SCASB
	JNE	notatt
	LEA	SI,DS:attcopy
	MOV	CX,17
repe	CMPSB
	JNE	notatt
	JMP	attnext
notatt:
	POP	ES
        pop     di
        pop     si
        pop     cx
	STC
	RET
attnext:
	POP	ES
        pop     di
        pop     si
        pop     cx
	clc
	ret
checkatt endp
;	port address
index	equ	03b4h
cntrl	equ	03b8h
;	control codes
scrn_on	equ	8
grph	equ	2
text	equ	20h
	
hgmode	proc	near
	PUSH	AX
	PUSH	BX
	PUSH	CX
	PUSH	DX
	PUSH	BP
	PUSH	SI
	PUSH	DI
	PUSH	ES
	MOV	DX,3bfh
	MOV	AL,3
	OUT	DX,AL
	mov	al,grph
	lea	si,DS:gtable
	mov	bx,0
	mov	cx,4000h
	call	setmd
	POP	ES
	POP	DI
	POP	SI
	POP	BP
	POP	DX
	POP	CX
	POP	BX
	POP	AX
	ret
hgmode	endp
; sets herc graphics mode
setmd	proc	near
;	sets mode to graphics or text
;	depending on al
;	si = parameter table
;	cx = number of words to be cleared
;	bx = blank value
	push	ax
	push	bx
	push	cx
;	change mode but without scrn_on
	mov	dx,cntrl
	out	dx,AL
;	intialize the 6845
	mov	dx,index
	mov	cx,12	;12 parameters to
	;be output
	xor	ah,ah	;starting from
	;reg. 0
parms:	mov	al,AH
	out	dx,al	;output register
	;number
	cld
	inc	dx
	lodsb
	out	dx,al	;output data
	inc	ah	;next value
	dec	dx
	loop	parms
	pop	cx	;clear the buffer
	mov	ax,0b000h
	mov	es,AX
	xor	di,DI
	pop	ax
	rep	stosw
	mov	dx,cntrl
	pop	ax
	add	al,scrn_on
	out	dx,AL
	ret
setmd	endp
; these are the public routines for tree
set_screens	proc	near
do_herc:
	CALL	setherc
	CALL	quit
	RET
do_vesa:
     call  checkvesa
     jc    not_a_vesa
     call  setvesa
not_a_vesa:
     call   quit
     ret
setvesa:
; have to find the best mode for us.
; 1) try 1024, 800 and 640
;        106h, 104h,   102h
;
         push  es
         les   di,vidmodes
         mov   cx,60
loop_1024:
         cmp   word ptr es:[di],0ffffh
         je    no_1024
         cmp   word ptr es:[di],106h
         je    got_1024
         inc   di
         inc   di
         loop  loop_1024
got_1024:
         mov   vesamode,106h
	MOV	vid_wid,160
	MOV	vid_len,1024
         jmp   done_vesa
no_1024:
         les   di,vidmodes
         mov   cx,20
loop_800:
         cmp   word ptr es:[di],0ffffh
         je    no_800
         cmp   word ptr es:[di],104h
         je    got_800
         inc   di
         inc   di
         loop  loop_800
got_800:
         mov   vesamode,104h
	MOV	vid_wid,128
	MOV	vid_len,768
         jmp   done_vesa
no_800:
         les   di,vidmodes
         mov   cx,20
loop_640:
         cmp   word ptr es:[di],0ffffh
         je    no_vesa
         cmp   word ptr es:[di],102h
         je    got_640
         inc   di
         inc   di
         loop  loop_640
         pop   es
         jmp   no_vesa
got_640:
         mov   vesamode,102h
	MOV	vid_wid,100
	MOV	vid_len,600
done_vesa:
; got the vesa mode
; sets the vesa mode
; set mode using VESA
        pop  es
        mov   mode,-1
	MOV	vbuffer,0a000h
	MOV	interlace,1
        call    set_mode
        mov  ah,4fh
        mov  al,2
        mov  bx,vesamode
        int  10h
	lea	dx,color_map
	mov	ah,10h	; set pallette
	mov	al,2
	int	10h
	CLC
	RET

checkvesa:
;
; check for VESA
;
        call  reset_segs
;
        mov   ah,4fh
        mov   al,0
        mov   di,offset vesablock
        int   10h
;
        cmp   word ptr vesablock,'EV'
        je   vesa1
        jmp   no_vesa
vesa1:
        cmp   word ptr vesablock+2,'AS'
        je   vesa2
        jmp   no_vesa
vesa2:
         mov   al,-1
         clc
        ret
no_vesa:
;	if VGA or EGA find the kind of monitor that's hooked up
;
        mov   ax,-1
        stc

        ret
do_640:
	CALL	set640
	CALL	quit
	RET
; these are the service color routines called by toggle_col
;
set_color:
        push    ax
        push    bx
        push    si
	MOV	AH,11
	MOV	BH,0
	INC	color
	MOV	BL,color
	INT	10h
        pop     si
        pop    bx
        pop    ax
	RET
set_palette:
        push    ax
        push    bx
        push    si
	MOV	AH,11
	MOV	BH,1
	INC	palette
	MOV	BL,palette
	INT	10h
        pop     si
        pop    bx
        pop    ax
	RET
set_screens endp
;
;
calc_last proc near
	call	reset_segs
; the last viewable si and seg are calculated here
;
; this time calculate the number of segs in a page
;
	mov	ax,vid_len
	mul	interlace
	mul	planes
;	dx:ax has the number of lines on a page
	imul	vwid	; bytes per page
	mov	cx,segmentsize
	div	cx
;	dx has the si offset, ax the segments in one page
	sub	ax,tot_mem
; xyzzy
	neg	ax
	cmp	dx,0
	je	store_last
	sub	dx,segmentsize
	neg	dx
	dec	ax
store_last:
; ax has the seg count, dx has si offset
	sub	dx,vid_wid
	cmp	dx,0
	jg	ok_seg
	add	dx,segmentsize
	dec	ax
ok_seg:
	dec	dx
	mov	last_si,dx
	mov	last_seg,ax
	cmp	tot_mem,ax
	jle	ok_max
;	call	blip
ok_max:
; now do the same for the fat_segs
	mov	ax,vid_len
	mul	interlace
	mul	planes
;	dx:ax has the number of lines on a page
	shr	ax,1
	shr	ax,1
	shr	ax,1	; divide by 8 to do fat bits
;
	imul	vwid	; bytes per page
	mov	cx,segmentsize
	div	cx
;	dx has the si offset, ax the segments in one page
	sub	ax,tot_mem
	neg	ax
	cmp	dx,0
	je	store_lastf
	sub	dx,segmentsize
	neg	dx
	dec	ax
store_lastf:
; ax has the seg count, dx has si offset
	sub	dx,vid_wid
	cmp	dx,0
	jg	ok_segf
	add	dx,segmentsize
	dec	ax
ok_segf:
	dec	dx
	mov	last_fsi,dx
	mov	last_fseg,ax
	cmp	tot_mem,ax
	jle	ok_maxf
;	call	blip
ok_maxf:
	ret
calc_last	endp
cseg	ends
	END
